#include<stdio.h>
#include<math.h>
#include"calculation.h"

void DisplayMatrix(Matrix *m);
void DisplayVector(Vector *v);

int main()
{
	Vector *original, *px;
	Matrix *p;
	double x1;
	double sum;
	int i, j;

	original = CreateVector(3);
	px = CreateVector(3);
	p = CreateMatrix(3, 3);
	
	original->v[0] = 1;
	original->v[1] = 1;
	original->v[2] = 1;

	printf("Original Vector:\n");
	DisplayVector(original);

	x1 = Householder(original);

	printf("Translated Vector:\n");
	printf("%f %f %f\n\n", x1, 0.0, 0.0);

	for(i=0; i<3; i++){
		for(j=0; j<3; j++){
			if(i==j){
				p->a[i*3 + j] = 1 - 2*original->v[i]*original->v[j];
			}
			else{
				p->a[i*3 + j] = -2*original->v[i]*original->v[j];
			}
		}
	}

	printf("Translate Matrix\n");
	DisplayMatrix(p);

	original->v[0] = 1;
	original->v[1] = 1;
	original->v[2] = 1;

	for(i=0; i<3; i++){
		for(j=0, sum=0.0; j<3; j++){
			sum += p->a[i*3 + j]*original->v[j];
		}
		px->v[i] = sum;
	}

	printf("Px:\n");
	DisplayVector(px);

	FreeVector(original);
	FreeVector(px);
	FreeMatrix(p);

	return 0;
}


void DisplayMatrix(Matrix *m)
{
	int i, j;

	for(i=0; i<m->height; i++){
		for(j=0; j<m->width; j++){
			printf("%f ", m->a[i*m->width + j]);
		}
		printf("\n");
	}
	printf("\n");
}

void DisplayVector(Vector *v)
{
	int i;

	for(i=0; i<v->size; i++){
		printf("%f ", v->v[i]);
	}
	printf("\n");
	printf("\n");
}

